import { Reducible, Action, Dispatch } from 'pretur.redux';
import { PageInstance } from './pageInstance';
import { Pages, PageInstantiationData } from './pages';
export declare function deisolate<A extends Action<any, any>>(action: A): A;
export interface PageReplaceOptions {
    toRemoveMutex: string;
    toInsertData: PageInstantiationData<any>;
}
export interface PageOpenOptions {
    path: string;
    mutex: string;
    reducerBuilderData?: any;
    titleData?: any;
    insertAfterMutex?: string;
}
export declare class Navigator implements Reducible {
    private _pages;
    private _prefix;
    private _instances;
    private _activePageMutex;
    constructor(pages: Pages, prefix?: string);
    readonly active: PageInstance<any, any, any> | undefined;
    readonly activeMutex: string | undefined;
    readonly all: PageInstance<any, any, any>[];
    reduce(action: Action<any, any>): this;
    transit(dispatch: Dispatch, mutex: string | undefined): void;
    open(dispatch: Dispatch, instantiationData: PageOpenOptions): void;
    replace(dispatch: Dispatch, toRemoveMutex: string, toInsertData: PageInstantiationData<any>): void;
    close(dispatch: Dispatch, mutex: string): void;
    load(dispatch: Dispatch): void;
    clear(dispatch: Dispatch): void;
}
